package app;

import java.util.Properties;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Dialog mit dem die Programm-Information angezeigt werden.
 * Es werden die Objekte <code>name, copyright, image</code> aus der Klasse
 * Applikation verwendet.<br>
 * <i>(C)opyright 2002 L.H.Hahn</i>
 * @author Dr. Lars H. Hahn
 * @version 3.0
 * @see Applikation
 */

public class DlgInfo
  extends JDialog {

  private final JTextArea textArea = new JTextArea(10, 30);
  private final JButton button = new JButton("GC starten");

  public DlgInfo(Applikation applikation) {
    super(applikation.getOberflaeche(), "Programm-Info", true);
    textArea.setEditable(true);
    textArea.selectAll();
    textArea.cut();
    textArea.setEditable(false);
    textArea.append(applikation.copyright+"\n");
    textArea.append("Fr "+applikation.name+" besteht KEINERLEI GARANTIE.\n");
    textArea.append(applikation.name+" ist freie Software, die Sie unter\n");
    textArea.append("bestimmten Bedingungen weitergeben drfen.\n");

    Properties prop = System.getProperties();
    textArea.append("\nBetriebssystem: "+prop.getProperty("os.name"));
    textArea.append("\nArchitektur: "+prop.getProperty("os.arch"));
    textArea.append("\nJava-VM Version: "+prop.getProperty("java.vm.version"));
    textArea.append("\nFreier Speicher: "+Runtime.getRuntime().freeMemory());
    textArea.append("\nGesamter Speicher: "+Runtime.getRuntime().totalMemory());
    textArea.setAlignmentX(LEFT_ALIGNMENT);

    button.setAlignmentX(LEFT_ALIGNMENT);
    button.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e) {
        System.gc();
        textArea.append("\nFreier Speicher: "+Runtime.getRuntime().freeMemory());
      }
    });
    this.getContentPane().add(new JLabel(new ImageIcon(applikation.image)), BorderLayout.WEST);
    this.getContentPane().add(Box.createRigidArea(new Dimension(5,0)), BorderLayout.CENTER);
    this.getContentPane().add(new JScrollPane(textArea), BorderLayout.EAST);
    this.getContentPane().add(button, BorderLayout.SOUTH);
    this.setResizable(false);
  }
}