package haushalt;

import javax.swing.JComboBox;
import java.awt.event.KeyEvent;

/**
 * @author Lars H. Hahn
 * @version 1.1
 */

public class BuchungsComboBox
  extends JComboBox
  implements BuchungsField {

  private Buchung buchung;
  private Register register; // in dem die Buchung steht (nur fuer Umbuchung)

  public BuchungsComboBox(StandardBuchung standardBuchung) {
    super(Kategorie.getKategorien(true));
    setSelectedItem(standardBuchung.getSplitBetrag().getValueAt(0,0));
    this.buchung = standardBuchung;
  }

  public BuchungsComboBox(Umbuchung umbuchung, Register register) {
    super(Register.getRegister());
    this.register = register;
    // Es muss immer das Register in der Buchung angezeigt werden,
    // in dem die Buchung nicht steht
    if(register == umbuchung.getQuellRegister())
      setSelectedItem(umbuchung.getZielRegister());
    else
      setSelectedItem(umbuchung.getQuellRegister());
    this.buchung = umbuchung;
  }

  public Buchung aktualisiereBuchung() {
    if(buchung.getClass() == StandardBuchung.class)
      ((StandardBuchung)buchung).getSplitBetrag().setValueAt(getSelectedItem().toString(),0,0);
    else {
      Umbuchung umbuchung = (Umbuchung)buchung;
      if(register == umbuchung.getQuellRegister()) { // Das Register aendern das man nicht sieht
        if(umbuchung.getZielRegister() != register)
          // Selbstbuchung nicht entfernen
          umbuchung.getZielRegister().entferneBuchung(umbuchung);
        umbuchung.setZielRegister(Register.findeRegister(getSelectedItem().toString()));
        if(umbuchung.getZielRegister() != register)
          // Selbstbuchung nicht doppelt einfgen
          umbuchung.getZielRegister().einsortierenBuchung(umbuchung);
      }
      else {
          // alle Selbstbuchung laufen vor das IF
        umbuchung.getQuellRegister().entferneBuchung(umbuchung);
        umbuchung.setQuellRegister(Register.findeRegister(getSelectedItem().toString()));
        if(umbuchung.getQuellRegister() != register)
          // ... aber Vorsicht, man keine eine daraus machen
          umbuchung.getQuellRegister().einsortierenBuchung(umbuchung);
      }
    }
    return buchung;
  }

  public void processKeyEvent(KeyEvent e) {
    super.processComponentKeyEvent(e);
// Baustelle!
  }

}