package haushalt;
import haushalt.werte.Euro;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.Color;
import java.awt.Component;

/**
 * @author Lars H. Hahn
 * @version 1.1
 */

public class BuchungsRenderer
  extends DefaultTableCellRenderer {

  public Component getTableCellRendererComponent(JTable table,
                                                 Object value,
                                                 boolean isSelected,
                                                 boolean hasFocus,
                                                 int row,
                                                 int col) {
    if(value.getClass() == StandardBuchung.class) {
      StandardBuchung buchung = (StandardBuchung)value;
      switch(col) {
        case 0: value = buchung.getDatum(); break;
        case 1: value = buchung.getText(); break;
        case 2: value = buchung.getSplitBetrag().toString(); break;
        case 3: value = buchung.getWert(); break;
      }
    }
    if(value.getClass() == Umbuchung.class) {
      Umbuchung buchung = (Umbuchung)value;
      boolean diesIstDasZielRegister = ((Register)table.getModel() == buchung.getZielRegister());
      switch(col) {
        case 0: value = buchung.getDatum(); break;
        case 1: value = buchung.getText(); break;
        case 2: {
                  if(diesIstDasZielRegister)
                    value = buchung.getQuellRegister();
                  else
                    value = buchung.getZielRegister();
                  break;
                }
        case 3: {
                  if(diesIstDasZielRegister)
                    value = buchung.getWert();
                  else
                    value = Euro.NULL_EURO.sub(buchung.getWert());
                  break;
                }
      }
    }
    Component comp = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, col);
    if((col != 3) || (Euro.NULL_EURO.compareTo(value) <= 0))
      comp.setForeground(Color.black);
    else
      comp.setForeground(Color.red);
    if(col == 3)
      ((JLabel)comp).setHorizontalAlignment(JLabel.RIGHT);
    else
      ((JLabel)comp).setHorizontalAlignment(JLabel.LEFT);
    return comp;
  }
}