package haushalt;
import haushalt.werte.Euro;
import app.*;

import java.awt.*;
import java.lang.reflect.*;
import javax.swing.*;
import javax.swing.table.DefaultTableCellRenderer;

/**
 * @author Lars H. Hahn
 * @version 1.1
 */

public class OberflaecheHaushalt
  extends JFrame {

  private final static boolean DEBUG = false;

  final private JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.BOTTOM);
  private boolean keinRegister = false; // damit der Hintergrund angezeigt wird
  private JLabel hintergrund;


  public OberflaecheHaushalt() {
    super("jHaushalt"); // vorlufiger Titel
    this.getContentPane().add(Box.createRigidArea(new Dimension(500,500)), BorderLayout.CENTER);
  }

  public void addHintergrund(JLabel hintergrund) {
    this.hintergrund = hintergrund;
    zeigeHintergrund();
  }

  public void zeigeHintergrund() {
    if(keinRegister == false) {
      tabbedPane.removeAll();
      this.getContentPane().removeAll();
      this.getContentPane().add(hintergrund, BorderLayout.CENTER);
      keinRegister = true;
      this.repaint();
    }
  }

  public void setTabPlacement(String tabPlacement) {
    int tp = SwingConstants.BOTTOM;
    Class c = SwingConstants.class;
    try {
      Field field = c.getField(tabPlacement);
      tp = field.getInt(new Integer(0));
    }
    catch(Exception e) {
      Applikation.fehlerAusgabe.println("-E- setTabPlacement: "+e);
    }
    tabbedPane.setTabPlacement(tp);
  }

// 2x table.addKeyListener() reg+buchungsEditor !!!
// -> alles nach buchungsEditor?
  public void zeigeRegister(Register reg) {
    JTable table = new JTable(reg);
    table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    table.setSelectionBackground(Color.lightGray);
    JScrollPane scrollPane = new JScrollPane(table);
    table.addKeyListener(reg);
    BuchungsEditor buchungsEditor = new BuchungsEditor(this);
    table.setDefaultEditor(Buchung.class, buchungsEditor);
    table.setDefaultRenderer(Buchung.class, new BuchungsRenderer());
    table.setDefaultRenderer(Euro.class, new DefaultTableCellRenderer(){
      public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
                                                     boolean hasFocus, int row, int col) {
        Component comp = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, col);
        if(Euro.NULL_EURO.compareTo(value) <= 0)
          comp.setForeground(Color.black);
        else
          comp.setForeground(Color.red);
        ((JLabel)comp).setHorizontalAlignment(JLabel.RIGHT);
        return comp;
      }
    });

    table.addKeyListener(buchungsEditor); // Falls der Editor kein Focus hat, trotzdem Split-Buchung waehlbar
    if(keinRegister) { // Hintergrund entfernen
      this.getContentPane().removeAll();
      this.getContentPane().add(tabbedPane, BorderLayout.CENTER);
      this.repaint();
      keinRegister = false;
    }
    this.tabbedPane.add(scrollPane, reg.toString());
    table.setRowSelectionInterval(table.getRowCount()-1,table.getRowCount()-1);
    JScrollBar scrollBar = scrollPane.getVerticalScrollBar();
    // JavaBug: Hier ist der maxValue noch 100 ...
    scrollBar.setValue(100);
    // Hier hat MaxValue den tatsaechlichen Wert ...
    scrollBar.setValue(scrollBar.getMaximum());
  }

  public void zeigeAlleRegister() {
    Register[] register = Register.getRegister();
    for(int i=0; i<register.length; i++) {
      // beim QuickenImport muss das doppelte Anzeigen verhindert werden
      boolean gefunden = false;
      for(int j=0; j<tabbedPane.getTabCount(); j++)
        if(register[i].toString().equals(tabbedPane.getTitleAt(j)))
          gefunden = true;
      if(!gefunden)
        zeigeRegister(register[i]);
    }
  }

  public void entferneRegister(String register) {
    for(int i=0; i<tabbedPane.getTabCount(); i++)
      if(register.equals(tabbedPane.getTitleAt(i)))
        tabbedPane.removeTabAt(i);
  }

  public void selektiereBuchung(Register register, int buchung) {
    for(int i=0; i<tabbedPane.getTabCount(); i++)
      if(register.toString().equals(tabbedPane.getTitleAt(i))) {
        tabbedPane.setSelectedIndex(i);
        JScrollPane scrollPane = (JScrollPane)tabbedPane.getComponentAt(i);
        JViewport viewport = (JViewport)scrollPane.getViewport();
        JTable table = (JTable)viewport.getComponent(0);
        table.setRowSelectionInterval(buchung, buchung);
        table.scrollRectToVisible(table.getCellRect(buchung, 0, true));
        if(DEBUG)
          System.out.println("Buchung Nr. "+buchung+" im Register "+register+" selektiert.");
        return;
      }
      if(DEBUG)
        System.out.println("Buchung Nr. "+buchung+" im Register "+register+" nicht gefunden!!!");
  }

}