package haushalt;
import haushalt.werte.*;
import app.Applikation;

import javax.swing.*;
import javax.swing.text.*;
import java.awt.event.*;

/**
 * @author Lars H. Hahn
 * @version 1.1
 */

public class PaneIntervall
  extends PaneMaster {

  private ZeitIntervall intervall;

  private final IntervallComboBox comboBox = new IntervallComboBox();
  private final JTextField textField;
  private final JPanel pane = new JPanel();

  public PaneIntervall(String textAufforderung) {
    textField = new JTextField() {
      protected Document createDefaultModel() {
        return new IntervallDocument();
      }
    };
    textField.setColumns(10);
    pane.add(comboBox);
    pane.add(textField);
    init(textAufforderung, pane);
  }

  protected void refreshWert() {
    wert = comboBox.getZeitIntervall(textField.getText());
    setAusgabe("Gewhlter Zeitraum: "+wert);
  }

  public JComponent getZentraleKomponente() {
    return textField;
  }

  private class IntervallDocument
    extends PlainDocument {
    public void insertString(int offs, String str, AttributeSet a)
      throws BadLocationException {
      char[] source = str.toCharArray();
      char[] result = new char[source.length];
      int j = 0;

      for (int i = 0; i < source.length; i++) {
        if ((Character.isDigit(source[i])) ||
            (source[i] == '/') ||
            (source[i] == '-') ||
            (source[i] == '.'))
          result[j++] = source[i];
        else
          Applikation.fehlerAusgabe.println("-I- Falsches Zeichen: " + source[i]);
      }

      super.insertString(offs, new String(result, 0, j), a);
    }
  }
}