package haushalt;

import javax.swing.*;


/**
 * @author Lars H. Hahn
 * @version 1.1
 */

abstract public class PaneMaster
  extends JPanel {

  private JPanel nummerPane = new JPanel();
  private JPanel compPane = new JPanel();
  private JTextField ausgabe = new JTextField(30);

  protected Object wert;

  protected PaneMaster() {
  }

  protected void init(String text, JComponent comp) {
    ausgabe.setEditable(false);
    compPane.setLayout(new BoxLayout(compPane, BoxLayout.Y_AXIS));
    this.add(nummerPane, null);
    this.add(compPane, null);
    JLabel label = new JLabel(text);
    label.setAlignmentX(LEFT_ALIGNMENT);
    compPane.add(label, null);
    comp.setAlignmentX(LEFT_ALIGNMENT);
    compPane.add(comp, null);
    ausgabe.setAlignmentX(LEFT_ALIGNMENT);
    compPane.add(ausgabe, null);
    this.refreshWert(); // damit 'wert != null'
  }

  protected void setAusgabe(String text) {
    ausgabe.setText(text);
  }

  public void setNummer(int nummer) {
    JLabel label = new JLabel(""+nummer+".");
    label.setFont(label.getFont().deriveFont(20F));
    nummerPane.add(label);
  }

  public Object getWert() {
    refreshWert();
    return wert;
  }

  abstract protected void refreshWert();

  abstract public JComponent getZentraleKomponente();

}