package haushalt;
import haushalt.werte.*;
import app.Applikation;

import java.io.*;

/**
 * @author Lars H. Hahn
 * @version 1.1
 */

public class Umbuchung
  extends Buchung {

  private Register quellRegister = null;
  private Register zielRegister = null;
  private Euro wert = new Euro();

  public Umbuchung() {
  }

  public Umbuchung(Datum datum, String text, String quelle, Euro wert) {
    setDatum(datum);
    setText(text);
    quellRegister = Register.findeRegister(quelle);
    if(quellRegister == null)
      Applikation.fehlerAusgabe.println("-E- Umbuchung: Quellregister '"+quelle+"' nicht gefunden!");
    this.wert = wert;
  }

  public String getBuchungsZeile(Register register) {
    if(register == zielRegister)
      return ""+getDatum()+"\t"+getText()+"\t"+quellRegister+"\t"+wert;
    return ""+getDatum()+"\t"+getText()+"\t"+zielRegister+"\t"+Euro.NULL_EURO.sub(wert);
  }

  public String getBuchungsZeile(Register register, Kategorie kategorie, boolean unterkategorien) {
    return null; // Umbuchung passt nie in eine Kategorie
  }

  public Object clone() {
    return new Umbuchung(getDatum(), getText(), quellRegister.toString(), wert);
  }

  public Euro getWert() {
    return wert;
  }

  public void setWert(Euro wert) {
    this.wert = wert;
  }

  public Register getQuellRegister() {
    return quellRegister;
  }

  public void setQuellRegister(Register quellRegister) {
    this.quellRegister = quellRegister;
  }

  public Register getZielRegister() {
    return zielRegister;
  }

  public void setZielRegister(Register zielRegister) {
    this.zielRegister = zielRegister;
  }

  public void summieren(ZeitIntervall intervall) {
    /**@todo: implement this haushalt.Buchung abstract method*/
  }

  public void ersetzeKategorie(Kategorie alteKategorie, Kategorie neueKategorie) {
    /**@todo: implement this haushalt.Buchung abstract method*/
  }

  public void laden(DataInputStream in)
    throws IOException {
    super.laden(in);
    String register = in.readUTF();
    quellRegister = Register.findeRegister(register);
    // Problem: Das Quell-Register der Umbuchung gibt es vielleicht noch nicht:
    if(quellRegister == null)  // also erzeugen!
      quellRegister = Register.erzeugeRegister(register);
    wert.laden(in);
  }

  public void speichern(DataOutputStream out)
    throws IOException {
    out.writeUTF("Umbuchung");
    super.speichern(out);
    out.writeUTF(quellRegister.toString());
    wert.speichern(out);
  }
}