package haushalt.werte;

import javax.swing.JTextField;
import javax.swing.text.*;

/**
 * Teil des Paketes 'werte' des Projektes jHaushalt.
 *
 * @author Lars H. Hahn
 * @version 1.1
 */

public class EuroField
  extends JTextField {

  public EuroField(Euro euro) {
    if(euro.equals(Euro.NULL_EURO))
      setText("");
    else
      setText(euro.toString());
  }

  public Euro getValue() {
    return new Euro(getText());
  }

  protected Document createDefaultModel() {
    return new EuroDocument();
  }

  private class EuroDocument
    extends PlainDocument {
    public void insertString(int offs, String str, AttributeSet a)
      throws BadLocationException {
      char[] source = str.toCharArray();
      int anzChar = source.length;
      char[] result = new char[anzChar];
      int j = 0;

      for (int i = 0; i < anzChar; i++) {
        if (Character.isDigit(source[i]) || (source[i] == '') || (source[i] == '-') ||
           (source[i] == ' ') || (source[i] == '.') || (source[i] == ','))
          result[j++] = source[i];
      }
      super.insertString(offs, new String(result, 0, j), a);
    }
  }
}