package haushalt.werte;

import java.util.StringTokenizer;

/**
 * Teil des Paketes 'werte' des Projektes jHaushalt.
 *
 * @author Lars H. Hahn
 * @version 1.1
 */

public class FreierZeitraum
  extends ZeitIntervall {

  private Datum startDatum = new Datum();
  private Datum endDatum = startDatum.addTage(14);

  public FreierZeitraum(int tag1, int monat1, int jahr1, int tag2, int monat2, int jahr2) {
    this.startDatum = new Datum(tag1, monat1, jahr1);
    this.endDatum = new Datum(tag2, monat2, jahr2);
  }

  public FreierZeitraum(Datum startDatum, Datum endDatum) {
    this.startDatum = startDatum;
    this.endDatum = endDatum;
  }

  public FreierZeitraum(String text) {
    try {
      StringTokenizer st = new StringTokenizer(text, "-");
      startDatum = new Datum(st.nextToken());
      endDatum = new Datum(st.nextToken());
    }
    catch(Exception e) {
      // Fehler! -> Standardwerte.
    }
  }

  public Datum getStartDatum() {
    return startDatum;
  }

  public Datum getEndDatum() {
    return endDatum;
  }

  public ZeitIntervall folgeIntervall() {
    return new FreierZeitraum(endDatum, endDatum.addTage(getAnzahlTage()));
  }

  public String toString() {
    return startDatum+"-"+endDatum;
  }

}