package haushalt.werte;

import java.util.StringTokenizer;

/**
 * Teil des Paketes 'werte' des Projektes jHaushalt.
 *
 * @author Lars H. Hahn
 * @version 1.1
 */

public class Halbjahr
  extends ZeitIntervall {

  private int haelfte = 1;
  private int jahr    = 2000;

  public Halbjahr(int haelfte, int jahr) {
    this.haelfte = haelfte;
    this.jahr = jahr;
  }

  public Halbjahr(String text) {
    try {
      StringTokenizer st = new StringTokenizer(text, "/");
      haelfte = Integer.parseInt(st.nextToken());
      jahr = Integer.parseInt(st.nextToken());
      if(haelfte > 2)
        haelfte = 2;
    }
    catch(Exception e) {
      // Fehler! -> Standardwerte.
    }
  }

  public Datum getStartDatum() {
    if(haelfte == 1)
      return new Datum(1,1,jahr);
    return new Datum(1,6,jahr);
  }

  public Datum getEndDatum() {
    if(haelfte == 1)
      return new Datum(1,6,jahr);
    return new Datum(1,1,jahr+1);
  }

  public ZeitIntervall folgeIntervall() {
    if(haelfte == 1)
      return new Halbjahr(2, jahr);
    return new Halbjahr(1, jahr+1);
  }

  public String toString() {
    return ""+haelfte+"HJ"+jahr;
  }

}