package haushalt.werte;

import javax.swing.JComboBox;

/**
 * Teil des Paketes 'werte' des Projektes jHaushalt.
 *
 * @author Lars H. Hahn
 * @version 1.1
 */

public class IntervallComboBox
  extends JComboBox {

  private static final String[] items = {
    "Monat (MM/JJJJ)",
    "Quartal (Q/JJJJ)",
    "Halbjahr (H/JJJJ)",
    "Jahr (JJJJ)",
    "Volles Jahr bis Datum (TT.MM.JJJJ)",
    "Jahresanfang bis Datum (TT.MM.JJJJ)",
    "Freier Zeitraum (TT.MM.JJJJ-TT.MM.JJJJ)"};

  public IntervallComboBox() {
    super(items);
  }

  public ZeitIntervall getZeitIntervall(String text) {
    switch(getSelectedIndex()) {
      case 0: return new Monat(text);
      case 1: return new Quartal(text);
      case 2: return new Halbjahr(text);
      case 3: return new Jahr(text);
      case 4: return new VollesJahrBisDatum(new Datum(text));
      case 5: return new JahresanfangBisDatum(new Datum(text));
      case 6: return new FreierZeitraum(text);
    }
    return null;
  }
}