package haushalt.werte;

import java.util.StringTokenizer;

/**
 * Teil des Paketes 'werte' des Projektes jHaushalt.
 *
 * @author Lars H. Hahn
 * @version 1.1
 */

public class Quartal
  extends ZeitIntervall {

  private int quartal = 1;
  private int jahr    = 2000;

  public Quartal(int quartal, int jahr) {
    this.quartal = quartal;
    this.jahr = jahr;
  }

  public Quartal(String text) {
    try {
      StringTokenizer st = new StringTokenizer(text, "/");
      quartal = Integer.parseInt(st.nextToken());
      jahr = Integer.parseInt(st.nextToken());
      if(quartal > 4)
        quartal = 4;
    }
    catch(Exception e) {
      // Fehler! -> Standardwerte.
    }
  }

  public Datum getStartDatum() {
      return getQuartalsBeginn(quartal, jahr);
  }

  public Datum getEndDatum() {
    if(quartal == 4)
      return getQuartalsBeginn(1, jahr+1);
    else
      return getQuartalsBeginn(quartal+1, jahr);
  }

  public ZeitIntervall folgeIntervall() {
    if(quartal == 4)
      return new Quartal(1, jahr+1);
    else
      return new Quartal(quartal+1, jahr);
  }

  private static Datum getQuartalsBeginn(int quartal, int jahr) {
    String datum = "";
    switch(quartal) {
      case 1: datum = "01.01."; break;
      case 2: datum = "01.04."; break;
      case 3: datum = "01.07."; break;
      case 4: datum = "01.10."; break;
    }
    return new Datum(datum+jahr);
  }

  public String toString() {
    return ""+quartal+"Q"+jahr;
  }

}